unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Tx4oleLib_TLB, OleCtrls;

type
  TForm1 = class(TForm)
    TXTextControl1: TTXTextControl;
    TXRuler1: TTXRuler;
    TXButtonBar1: TTXButtonBar;
    TXStatusBar1: TTXStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    Delete1: TMenuItem;
    Function toTwips(I : Integer): Integer;
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure TXTextControl1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure TXTextControl1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    gblStart, gblLength : Integer;
    dragging : Boolean;
    data : OleVariant;
  public
    { Public declarations }
  end;

const TWIP_PIXEL_FACTOR = (1440 div 96);

var
  Form1: TForm1;


implementation

{$R *.DFM}

Function TForm1.toTwips(I : Integer): Integer;
begin
     toTwips := I * TWIP_PIXEL_FACTOR;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    TXTextControl1.ButtonBarHandle := TXButtonBar1.hWnd;
    TXTextControl1.RulerHandle := TXRuler1.hWnd;
    TXTextControl1.StatusBarHandle := TXStatusBar1.hWnd;
    TXTextControl1.FormatSelection := True;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
    If WindowState <> wsMinimized Then
        TXTextControl1.Height := ClientHeight - TXButtonBar1.Height - TXRuler1.Height - TXStatusBar1.Height;
end;

procedure TForm1.Cut1Click(Sender: TObject);
begin
     TXTextControl1.Clip (1);
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
     TXTextControl1.Clip (2);
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
     TXTextControl1.Clip (3);
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
     TXTextControl1.Clip (4);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.TXTextControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   pos : LongInt;
begin
    //Get current input position and the current selection
    pos := TXTextControl1.InputPosFromPoint(toTwips(X), toTwips(Y));
    gblStart := TXTextControl1.SelStart;
    gblLength := TXTextControl1.SelLength;

    //Check if the click occured in the current selection
    If (gblStart <= pos) And (gblStart + gblLength > pos) Then begin
        //Start dragging
        data := TXTextControl1.SaveToMemory(3, True);
        dragging := true;
        Cursor := 2;
        TXTextControl1.EditMode := 2;
    End;
end;

procedure TForm1.TXTextControl1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   pos : LongInt;
begin

    pos := TXTextControl1.InputPosFromPoint(toTwips(X), toTwips(Y));

    If dragging Then begin
        //Check if the new input position is outside of
        //the current selection. If it's not, do not
        //copy the text
        If Not ((gblStart <= pos) And (gblStart + gblLength > pos)) Then begin
            TXTextControl1.SelText := '';
            If pos < gblStart Then
                TXTextControl1.SelStart := pos
            Else
                TXTextControl1.SelStart := pos - gblLength;

            TXTextControl1.LoadFromMemory(data, 3, True);
        End;
        //End dragging
        dragging := False;
        Cursor := 0;
        TXTextControl1.EditMode := 0;
    End;
end;

end.
