unit Forms2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, StdCtrls, ComCtrls, Tx4oleLib_TLB, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    Exit1: TMenuItem;
    PrintDialog1: TPrintDialog;
    TXButtonBar1: TTXButtonBar;
    TXRuler1: TTXRuler;
    TXStatusBar1: TTXStatusBar;
    LoadBackgroundImage1: TMenuItem;
    View1: TMenuItem;
    Zoom1: TMenuItem;
    N301: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N2001: TMenuItem;
    TXParent: TTXTextControl;
    TXChild1: TTXTextControl;
    procedure TXParentMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TXChild1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Connect(n: Integer);
    procedure LoadBackgroundImage1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure N301Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N751Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    Function toTwip(I :Integer): Integer;
    procedure TXChild1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public

  end;

var
  Form1: TForm1;
  MaxID : Integer;
  TXhWnd : TComponent;
  Zoom: Integer;
Const
  FILE_ID = 12345;
  PRINT_MARGIN = 566; // 1 cm
type
    TX_PRO = record
      xPos : Integer;
      yPos : Integer;
      xSize : Integer;
      ySize : Integer;
    end;
type
    FILE_HEADER = record
      lVersion : LongInt;
    end;

implementation

uses printers;

{$R *.DFM}

procedure TForm1.TXParentMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   TX: TTXTextControl;
   i : Integer;
begin
  if (ssCtrl in Shift) then begin
     MaxID := MaxID + 1;
     TX := TTXTextControl.Create(Form1);
     TX.Parent := TXParent;
     TX.Top := Y;
     TX.Left := X;
     TX.Width := TXChild1.Width;
     TX.Height := TXChild1.Height;
     TX.Name := 'TXChild' + InttoStr(MaxID);
     Connect (MaxID); // Connect new control with Statusbar, etc.
     TX.SizeMode := 3; // Move- and sizeable
     TX.ClipSiblings := false;
     TX.BackStyle := 0;
     TX.BringtoFront;
     TX.OnMouseDown := TXChild1MouseDown;
  end;
For i := 1 to MaxID do begin
   TXhWnd := FindComponent('TXChild' + Inttostr(i));
   TTXTextControl(TXhWnd).BringtoFront;
   end;

end;

procedure TForm1.TXChild1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     TTXTextControl(Sender).BringtoFront;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     MaxID := 1;
     Connect (MaxID);
end;

procedure TForm1.Load1Click(Sender: TObject);
var
    lFilePos : LongInt;
    FileID : FILE_HEADER;
    Filename : String;
    TX : TTXTextControl;
    InpFile    : file of byte;
    bOpen : Boolean;
    TXProp : TX_PRO;
    i : Integer;
begin
   // Create an "Open File" dialog box
  OpenFileDialog.Title := 'Open file';
  OpenFileDialog.Filename := '';
  OpenFileDialog.Filter := 'TX Form Demo (*.txf)|*.txf';
  OpenFileDialog.FilterIndex := 1;

 if OpenFileDialog.Execute then
   Filename := OpenFileDialog.Filename
 else Exit;

 bOpen := False;
 try
   begin
    // Open the selected file
    AssignFile(inpFile, filename);
    reset(inpFile);
    bOpen := True;

    // Read file header
    BlockRead(inpFile, FileID, sizeOf(FileID));
    If FileID.lVersion <> FILE_ID Then begin
       MessageDlg('Wrong filetype: ' + filename, mtError,[mbOK],0);
       Exit;
    End;

   // Destroy existing controls
   If MaxID > 1 then begin
       For i := 2 To MaxID do
       begin
           TXhWnd := FindComponent('TXTextControl' + Inttostr(i));
           TTXTextControl(TXhWnd).Free;
       end;
   end;

   //Create text controls and load their contents
   BlockRead(InpFile, MaxID, sizeof(MaxID));
   For i := 1 To MaxID do begin
        BlockRead(InpFile, TXProp, sizeof(TXProp));
        If i <> 1 Then begin
                TX := TTXTextControl.Create(Form1);
                TX.Parent := TXParent;
                TX.Width := TXChild1.Width;
                TX.Height := TXChild1.Height;
                TX.Name := 'TXChild' + InttoStr(i);
                TX.SizeMode := 3;
                TX.ClipSiblings := false;
                TX.BackStyle := 0;
                Connect (i);
                TX.BringtoFront;
                TX.OnMouseDown := TXChild1MouseDown;
        end;
        TXhWnd := FindComponent('TXChild' + Inttostr(i));
        TTXTextControl(TXhWnd).Left := TXProp.xPos;
        TTXTextControl(TXhWnd).Top := TXProp.yPos;
        TTXTextControl(TXhWnd).Width := TXProp.xSize;
        TTXTextControl(TXhWnd).Height := TXProp.ySize;
        TTXTextControl(TXhWnd).Text := '';
    end;
    lFilePos := FilePos(InpFile);
    closeFile(InpFile);
    bOpen := False;

    For i := 1 To MaxID do begin
        TXhWnd := FindComponent('TXChild' + Inttostr(i));
        lFilePos := TTXTextControl(TXhWnd).Load(FileName, lFilePos, 3, False);
        TTXTextControl(TXhWnd).Visible := True;
    end;
   end;
  Except
       MessageDlg('Error opening ' + filename, mtError, [mbOK], 0);
       if bOpen then begin
          closeFile(inpFile);
       end;
    end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
    FileID : FILE_HEADER;
    Filename : String;
    outFile    : file of byte;
    TXProp : TX_PRO;
    i : Integer;
begin
  // Create an "Open File" dialog box
  SaveDialog1.Title := 'Save as';
  SaveDialog1.Filename := '';
  SaveDialog1.DefaultExt := 'txm';
  SaveDialog1.Filter := 'TX Form Demo (*.txf)|*.txf';
  SaveDialog1.FilterIndex := 1;

 if SaveDialog1.Execute then
   Filename := SaveDialog1.Filename
 else
     Exit;

 try
     begin
    // Open the selected file
    AssignFile(outFile, filename);
    rewrite(outFile);
    // Write file header
    FileID.lVersion := File_ID;
    BlockWrite(outFile, FileID, sizeOf(FileID));

   //Save properties of all text controls
   BlockWrite(outFile, MaxID, sizeof(MaxID));
   For i := 1 To MaxID do begin
        TXhWnd := FindComponent('TXChild' + Inttostr(i));
        with TXProp do begin
             xPos := TTXTextControl(TXhWnd).Left;
             yPos := TTXTextControl(TXhWnd).Top;
             xSize := TTXTextControl(TXhWnd).Width;
             ySize := TTXTextControl(TXhWnd).Height;
        end;
        BlockWrite(outFile, TXProp, sizeof(TXProp));
    end;
    closeFile(outFile);

    //Save contents of all text controls
    For i := 1 to MaxID do begin
        TXhWnd := FindComponent('TXChild' + InttoStr(i));
        TTXTextControl(TXhWnd).Save(FileName, -1, 3, False);
        end;
   end;
  Except
       MessageDlg('Error saving ' + filename, mtError, [mbOK], 0);
    end;

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
   i : Integer;
begin
     Printer.BeginDoc;
     For i := 1 To MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).PrintDevice := Printer. Handle;
         TTXTextControl(TXhWnd).PageMarginL := toTwip(TTXTextControl(TXhWnd).Left);
         TTXTextControl(TXhWnd).PageMarginT := toTwip(TTXTextControl(TXhWnd).Top);
         TTXTextControl(TXhWnd).PrintPage (1);
         end;
     Printer.NewPage;
     Printer.EndDoc;
end;

procedure TForm1.Connect (n : Integer);
begin
     TXhWnd := FindComponent('TXChild' + InttoStr(n));
     TTXTextControl(TXhWnd).ButtonBarHandle := TXButtonBar1.Handle;
     TTXTextControl(TXhWnd).RulerHandle := TXRuler1.Handle;
     TTXTextControl(TXhWnd).StatusBarHandle := TXStatusBar1.Handle;
end;

procedure TForm1.LoadBackgroundImage1Click(Sender: TObject);
begin
    TXParent.ObjectInsertAsChar (0, 'fax.tif', 1, 100, 100, 2, 0, 0);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
    TXParent.Height := ClientHeight - TXRuler1.Height
    - TXStatusBar1.Height - TXButtonBar1.Height;
end;

procedure TForm1.N301Click(Sender: TObject);
var
   i : Integer;
begin
     Zoom := TXParent.ZoomFactor;
     TXParent.ZoomFactor := 30;
     For i := 1 to MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).ZoomFactor := 30;
     end;
     TXhWnd := FindComponent('N' + InttoStr(Zoom) + '1');
     TMenuItem(TXhWnd).Checked := False;
     N301.Checked := True;
end;

procedure TForm1.N2001Click(Sender: TObject);
var
   i : Integer;
begin
     Zoom := TXParent.ZoomFactor;
     TXParent.ZoomFactor := 200;
     For i := 1 to MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).ZoomFactor := 200;
     end;
     TXhWnd := FindComponent('N' + InttoStr(Zoom) + '1');
     TMenuItem(TXhWnd).Checked := False;
     N2001.Checked := True;
end;

procedure TForm1.N501Click(Sender: TObject);
var
   i : Integer;
begin
     Zoom := TXParent.ZoomFactor;
     TXParent.ZoomFactor := 50;
     For i := 1 to MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).ZoomFactor := 50;
     end;
     TXhWnd := FindComponent('N' + InttoStr(Zoom) + '1');
     TMenuItem(TXhWnd).Checked := False;
     N501.Checked := True;
end;

procedure TForm1.N751Click(Sender: TObject);
var
   i : Integer;
begin
     Zoom := TXParent.ZoomFactor;
     TXParent.ZoomFactor := 75;
     For i := 1 to MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).ZoomFactor := 75;
     end;
     TXhWnd := FindComponent('N' + InttoStr(Zoom) + '1');
     TMenuItem(TXhWnd).Checked := False;
     N751.Checked := True;
end;

procedure TForm1.N1001Click(Sender: TObject);
var
   i : Integer;
begin
     Zoom := TXParent.ZoomFactor;
     TXParent.ZoomFactor := 100;
     For i := 1 to MaxID do begin
         TXhWnd := FindComponent('TXChild' + InttoStr(i));
         TTXTextControl(TXhWnd).ZoomFactor := 100;
     end;
     TXhWnd := FindComponent('N' + InttoStr(Zoom) + '1');
     TMenuItem(TXhWnd).Checked := False;
     N1001.Checked := True;
end;

Function TForm1.toTwip(I :Integer): Integer;
begin
     toTwip := I * (1440 div Form1.PixelsPerInch);
end;

procedure TForm1.TXChild1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     TTXTextControl(Sender).BringtoFront;
end;

end.
