unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, Tx4oleLib_TLB;

type
  TForm1 = class(TForm)
    TXTextControl1: TTXTextControl;
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    HypertextLink1: TMenuItem;
    View1: TMenuItem;
    HypertextLinks1: TMenuItem;
    Insert1: TMenuItem;
    HypertextLink2: TMenuItem;
    File1: TMenuItem;
    Open1: TMenuItem;
    Saveas1: TMenuItem;
    Target1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure HypertextLink1Click(Sender: TObject);
    procedure TXTextControl1FieldSetCursor(Sender: TObject;
      FieldId: Smallint; var MousePointer: Smallint);
    procedure HypertextLinks1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure HypertextLink2Click(Sender: TObject);
    procedure Target1Click(Sender: TObject);
    procedure TXTextControl1FieldLinkClicked(Sender: TObject; FieldId,
      FieldType: Smallint; var TypeData: WideString);
    procedure Saveas1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.DFM}

procedure TForm1.FormResize(Sender: TObject);
begin
     TXTextControl1.Height := ClientHeight;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    TXTextControl1.PageHeight := 15000;
    TXTextControl1.ScrollBars := 3;
end;

procedure TForm1.Insert1Click(Sender: TObject);
begin
     Hypertextlink2.Enabled := (TXTextControl1.FieldAtInputPos = 0);
end;

procedure TForm1.HypertextLink1Click(Sender: TObject);
begin
    Form2.ShowModal;
end;

procedure TForm1.TXTextControl1FieldSetCursor(Sender: TObject;
  FieldId: Smallint; var MousePointer: Smallint);
begin
     MousePointer := 12;
end;



procedure TForm1.HypertextLinks1Click(Sender: TObject);
begin
    HypertextLinks1.Checked := Not Hypertextlinks1.Checked;
    HighlightHyperlinks(TXTextControl1, Hypertextlinks1.Checked);
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
     Hypertextlink1.Enabled := (TXTextControl1.FieldAtInputPos <> 0);
end;

procedure TForm1.HypertextLink2Click(Sender: TObject);
begin
    Form2.ShowModal;
end;

//
// Target1Click
//
// Insert a target (aka bookmark or anchor).
//
procedure TForm1.Target1Click(Sender: TObject);
var
   TargetName : String;
begin
    TargetName := InputBox('Target name:', 'Insert target', ''); 
    If TargetName <> '' Then begin
        TXTextControl1.FieldInsert ('');
        TXTextControl1.FieldType[TXTextControl1.FieldCurrent] := txFieldLinkTarget;
        TXTextControl1.FieldTypeData[TXTextControl1.FieldCurrent] := TargetName;
    End;
end;

procedure TForm1.TXTextControl1FieldLinkClicked(Sender: TObject; FieldId,
  FieldType: Smallint; var TypeData: WideString);
begin
    If FieldType = txFieldInternalLink Then
        TXTextControl1.FieldGoto(txFieldLinkTarget, TypeData);
end;

procedure TForm1.Saveas1Click(Sender: TObject);
begin
     SaveDialog1.Title := 'Save As';
     SaveDialog1.Filter := 'HTML documents (*.html)|*.htm*';
     SaveDialog1.DefaultExt := 'html';
     SaveDialog1.Filename := '';

     if SaveDialog1.Execute then
        TXTextControl1.Save(SaveDialog1.FileName, 0, 4, false);


end;

procedure TForm1.Open1Click(Sender: TObject);
begin
     OpenDialog1.Title := 'Open';
     OpenDialog1.Filter := 'HTML documents (*.html)|*.htm*';
     OpenDialog1.DefaultExt := 'html';
     OpenDialog1.Filename := '';

     if OpenDialog1.Execute then
        TXTextControl1.Load(OpenDialog1.FileName, 0, 4, false);


end;

end.
