unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tx4oleLib_TLB, Unit3, OleCtrls;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    txtLinkedText: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    txtLinkTarget: TEdit;
    Label3: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Label4: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    txhidden: TTXTextControl;
    OpenDialog1: TOpenDialog;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    Procedure FillListboxWithTargets(no : Integer);
    procedure ListBox1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure CheckFileForTargets(tfile : String);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  tx : TTXTextControl;
  loadedFile : String;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
// If the caret is inside an existing hyperlink, copy the hyperlink' text and link
// information to the text boxes on the form.

    tx := Form1.TXTextControl1;

    If (Form1.TXTextControl1.FieldAtInputPos <> 0) Then  begin
        txtLinkedText.Text := tx.FieldText;
        txtLinkTarget.Text := tx.FieldTypeData[Form1.TXTextControl1.FieldCurrent];
    end Else begin
        txtLinkedText.Text := tx.SelText;
        txtLinkTarget.Text := '';
    end;

    txhidden.Left := -1000;
    FillListboxWithTargets(0);
end;

procedure TForm2.btnOKClick(Sender: TObject);
var
   LinkType : Integer;
begin
    If (txtLinkedText.Text = '') Then
        MessageBox(0, 'Hyperlink contains no text. Please enter the text to be shown as a hyperlink in the Linked Text field.', 'ERROR', MB_OK)
    Else If (txtLinkTarget.Text = '') Then
        MessageBox(0, 'No target specified. Please enter a target URL in the Link To field.', 'ERROR', MB_OK)
    Else begin
        // determine which type of link we have (see List1_Click()) and remove
        // the '#' charaacter.

        If (copy(txtLinkTarget.Text, 0, 1) = '#') Then begin
            LinkType := txFieldInternalLink;
            txtLinkTarget.Text := copy(txtLinkTarget.Text, 1, Length(txtLinkTarget.Text) - 1);
        end Else
            LinkType := txFieldExternalLink;

        If tx.FieldAtInputPos <> 0 Then begin
            // editing an existing hyperlink
            tx.FieldText := txtLinkedText.Text;
            tx.FieldType[tx.FieldCurrent] := LinkType;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
        end Else begin
            // insert new hyperlink
            tx.FieldInsert (txtLinkedText.Text);
            tx.FieldType[tx.FieldCurrent] := LinkType;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
        End;
        HighlightHyperlinks (tx, Form1.HypertextLinks1.Checked);
        close;
    End;
end;

//
// FillListboxWithTargets
//
// Loop through all Marked Text Fields which are of type target and add
// them to the listbox.
//
Procedure TForm2.FillListboxWithTargets(no : Integer);
var
    FieldID : Integer;
    ttx : TTXTextControl;
begin
    ListBox1.clear;

    if no = 0 then
       ttx := tx
    else
       ttx := txhidden;

    FieldID := ttx.FieldNext(0, $100);
    While FieldID <> 0 do begin
        ListBox1.Items.Add(ttx.FieldTypeData[FieldID]);
        FieldID := ttx.FieldNext(FieldID, $100);
    end;
end;

procedure TForm2.ListBox1Click(Sender: TObject);
begin
     txtLinkTarget.Text := loadedFile + '#' + ListBox1.Items.Strings[ListBox1.ItemIndex];
end;

procedure TForm2.RadioButton1Click(Sender: TObject);
begin
     FillListboxWithTargets (0);
end;

procedure TForm2.RadioButton2Click(Sender: TObject);
begin
     FillListboxWithTargets (1);
end;

procedure TForm2.CheckFileForTargets(tfile : String);
begin
    txhidden.LoadSaveAttribute[txEnableLinks] := True;
    txhidden.Load (tfile, 0, 4, false);
    FillListboxWithTargets (1);
    RadioButton2.Checked := True;
    loadedFile := tfile;
End;

procedure TForm2.Button1Click(Sender: TObject);
begin
     OpenDialog1.Title := 'Open';
     OpenDialog1.Filter := 'HTML documents (*.html)|*.htm*';
     OpenDialog1.DefaultExt := 'html';
     OpenDialog1.Filename := '';

     if OpenDialog1.Execute then begin
        txhidden.Load(OpenDialog1.FileName, 0, 4, false);
        txtLinkTarget.Text := OpenDialog1.FileName;
        CheckFileForTargets (OpenDialog1.FileName);
     end;
end;

end.
