unit preview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmPrintPreview = class(TForm)
    cmdCancel: TButton;
    Label1: TLabel;
    ViewPage: TImage;
    ForeButton: TButton;
    BackButton: TButton;
    Edit1: TEdit;
    Button1: TButton;
    procedure cmdCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure ForeButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    nOldPrintZoom : Integer;
    nCurPage      : Integer;
    procedure ShowPage;
end;

var
  frmPrintPreview: TfrmPrintPreview;

implementation

uses MDIEdit, MDIFrame;

{$R *.DFM}

procedure TfrmPrintPreview.cmdCancelClick(Sender: TObject);
begin
  TEditForm(FrameForm.ActiveMDIChild).TX.PrintZoom := nOldPrintZoom;
  Close;
end;

procedure TfrmPrintPreview.FormShow(Sender: TObject);
var nZoomH, nZoomW : Integer;
    nPageHeightInPixels, nPageWidthInPixels: Integer;
begin
  with TEditForm(FrameForm.ActiveMDIChild) do begin

     { Set zoom factor for Text Control's print function }
     nOldPrintZoom := TX.PrintZoom;
     nPageHeightInPixels := TX.PageHeight * PixelsPerInch div 1440;
     nPageWidthInPixels := TX.PageWidth * PixelsPerInch div 1440;
     nZoomH := (ViewPage.Height * 100) div nPageHeightInPixels;
     nZoomW := (ViewPage.Width * 100) div nPageWidthInPixels;

     If nZoomH < nZoomW Then
       TX.PrintZoom := nZoomH
     Else
       TX.PrintZoom := nZoomW;

     { Show first document page }
     nCurPage:=1;
     ShowPage;

   end;
end;

procedure TfrmPrintPreview.ShowPage;
begin
  Label1.Caption := 'Page: ' + IntToStr(nCurPage);

  with TEditForm(FrameForm.ActiveMDIChild) do begin
      TX.PrintDevice := ViewPage.Canvas.Handle;
      TX.PrintPage(nCurPage);
      ViewPage.Refresh;
      ForeButton.Enabled := (nCurPage < TX.CurrentPages);
      BackButton.Enabled := (nCurPage > 1);
    end;
end;

procedure TfrmPrintPreview.BackButtonClick(Sender: TObject);
begin
  dec(nCurPage);
  ShowPage;
end;

procedure TfrmPrintPreview.ForeButtonClick(Sender: TObject);
begin
  inc(nCurPage);
  ShowPage;
end;

procedure TfrmPrintPreview.Button1Click(Sender: TObject);
var
     zoom : Integer;
begin
     Zoom := (StrtoInt(Edit1.Text) + 20) mod 200;
     if Zoom = 0 then zoom := 20;
     TEditForm(FrameForm.ActiveMDIChild).TX.PrintZoom := zoom;
     Edit1.text := InttoStr(zoom);
     nCurPage := 1;
     ShowPage;
end;

end.
