unit Module1;

interface

uses   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   OleCtrls, Menus, Tx4oleLib_TLB, PgrulLib_TLB, OleCtnrs, StdCtrls;

const
PAGE_BORDER = 360;      // The border which is displayed around
                       // document pages (1/4 inch)
PGRULER_WIDTH = 360;    // Width of page ruler
CANCEL_ERR = 32755;
GET_FILE_HANDLE = 2;   // Constant for FileAttr function
CR = $D;               // CR/LF characters
LF = $A;
MAXINT = 32767;
DOC_VERSION = 23;      // Version number for document files

// Prorotypes and constant values for TX.DLL calls
WM_USER = $400;
TX_GETRECT = WM_USER + 107;
WM_SETREDRAW = $B;
TX_GETTEXTSIZE = WM_USER + 112;

GWL_STYLE = (-16);
WS_CLIPSIBLINGS = $4000000;

// Errors
ERR_DOC_VERSION = 32767;

//DEFAULT measurement for dialog boxes and rulers
M_INCH = 1;
M_CM = 2;
GS_INCH = 'inch';
GS_CM = 'cm';

// Global document data structure
Type DOC_DATA = record
    // Page size and margins (in twips)
    lLeftMargin : LongInt;
    lTopMargin : LongInt;
    lRightMargin : LongInt;
    lBottomMargin : LongInt;
    lHeight : LongInt;
    lWidth : LongInt;
    // Paper size
    nPaperSize : Integer;
    // Zoom factor
    lZoom : LongInt;
    // Number of pages and text controls in the document
    nTextControls : Integer;
    nPages : Integer;
    // Currently active page
    nActivePage : Integer;
End;

Type FILE_HEADER = Record
    lVersion : LongInt;
    DocData : DOC_DATA;
End;

Type RECT32 = Record
    left : LongInt;
    top : LongInt;
    right : LongInt;
    bottom : LongInt;
End;

Type RECT16 = Record
    left : Integer;
    top : Integer;
    right : Integer;
    bottom : Integer;
End;

Function lmax(l1, l2 : LongInt) : LongInt;
Function lmin(l1, l2 : LongInt) : LongInt;
Function nmax(n1 : Integer; n2 : Integer) : Integer;

var
ctrParam : TTXTextControl;
glnMeasurement : Integer;
doc : DOC_DATA;
TWIP_PIXEL_FACTOR : Integer;
TXhWnd : TTXTextControl;

implementation

Function lmax(l1, l2 : LongInt) : LongInt;
begin
    If (l1 > l2) Then lmax := l1
    Else lmax := l2;
End;

Function lmin(l1, l2 : LongInt) : LongInt;
begin
    If (l1 < l2) Then lmin := l1
    Else lmin := l2;
End;

Function nmax(n1 : Integer; n2 : Integer) : Integer;
begin
    If (n1 > n2) Then nmax := n1
    Else nmax := n2;
End;

end.
